"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _selectOne = _interopRequireDefault(require("jsonthefly/array/selectOne"));

var _ValidationResult = _interopRequireDefault(require("./ValidationResult"));

var _AsyncValidation = require("./AsyncValidation");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function upperFirst(str) {
  if (!str) return str;
  return str.charAt(0).toUpperCase() + str.slice(1);
} // initial state is required
//
// to implement
// syncValidateAll
// isSyncValid(oneOrAll)
// isAsyncValid(oneOrAll)
// isValid(oneOrAll)
// The next major version of this module will be able to customize naming methods and state interface.


var ReactFormObserver =
/*#__PURE__*/
function () {
  function ReactFormObserver() {
    _classCallCheck(this, ReactFormObserver);

    throw new Error("ReactFormObserver denies construction.");
  }

  _createClass(ReactFormObserver, null, [{
    key: "hasName",
    value: function hasName(state, name) {
      return Object.prototype.hasOwnProperty.call(state, name);
    } // This group of naming methods is the abstaction layer to keep the state in one depth for PureComponent

  }, {
    key: "getTouchedName",
    value: function getTouchedName(name) {
      return "is".concat(upperFirst(name), "Touched");
    }
  }, {
    key: "getValidationName",
    value: function getValidationName(name) {
      return "is".concat(upperFirst(name), "Valid");
    }
  }, {
    key: "getErrorName",
    value: function getErrorName(name) {
      return "".concat(name, "ErrorMessage");
    }
  }, {
    key: "getAsyncValidationName",
    value: function getAsyncValidationName(name) {
      return "".concat(name, "AsyncValidation");
    } // This group of reducing methods is the abstaction layer to modify the state of the subject.

  }, {
    key: "reduceTouched",
    value: function reduceTouched(name) {
      var tf = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      this.setState(function (prev) {
        return ReactFormObserver.hasName(prev, name) ? _defineProperty({}, ReactFormObserver.getTouchedName(name), tf) : null;
      });
    } // 'validate' returns an instance of ValidationResult

  }, {
    key: "reduceValue",
    value: function reduceValue(name, value, validate) {
      this.setState(function (prev) {
        return ReactFormObserver.hasName(prev, name) ? _defineProperty({}, name, value) : null;
      });

      if (typeof validate === "function") {
        this.setState(function (prev, props) {
          var _ref3;

          if (!ReactFormObserver.hasName(prev, name)) {
            return null;
          }

          var result;

          try {
            result = validate(value, prev, props);

            if (!(result instanceof _ValidationResult.default)) {
              result = {
                value: false,
                message: "'validate' should return an instance of ValidationResult."
              };
            }
          } catch (err) {
            result = {
              value: false,
              message: err instanceof Error ? err.message : "'validate' has thrown an non-Error object"
            };
          }

          return _ref3 = {}, _defineProperty(_ref3, ReactFormObserver.getValidationName(name), result.value), _defineProperty(_ref3, ReactFormObserver.getErrorName(name), result.message), _ref3;
        });
      } else {
        this.setState(function (prev) {
          var _ref4;

          return ReactFormObserver.hasName(prev, name) ? (_ref4 = {}, _defineProperty(_ref4, ReactFormObserver.getValidationName(name), true), _defineProperty(_ref4, ReactFormObserver.getErrorName(name), ""), _ref4) : null;
        });
      }
    } // an asyncValidator returns a promise that returns a boolean or throws an error.

  }, {
    key: "reduceAsyncValidation",
    value: function reduceAsyncValidation(name, asyncValidate, handleError) {
      var _this = this;

      this.setState(function (prev) {
        if (!ReactFormObserver.hasName(prev, name)) {
          return null;
        }

        var validationName = ReactFormObserver.getValidationName(name);

        if (prev[validationName] === true) {
          var currentValue = prev[name];
          var asyncValidationName = ReactFormObserver.getAsyncValidationName(name);
          var asyncValidation = prev[asyncValidationName] = prev[asyncValidationName] || [];
          var result = (0, _selectOne.default)(asyncValidation, "value", currentValue);

          if (!result || result.status === "ERROR") {
            var asyncValidator = asyncValidate(currentValue);

            if (asyncValidator instanceof Promise) {
              asyncValidator.then(ReactFormObserver.getAsyncValidationReducer.bind(_this)(asyncValidationName, currentValue), ReactFormObserver.getAsyncValidationErrorReducer.bind(_this)(asyncValidationName, currentValue, handleError));
            } else {
              throw new TypeError("'asyncValidate' should return a promise.");
            }
          }

          if (!result) {
            asyncValidation.push(new _AsyncValidation.AsyncValidation(currentValue, _AsyncValidation.AsyncValidationStatus.PENDING));
            return _defineProperty({}, asyncValidationName, _toConsumableArray(asyncValidation)); // for pure. this will vary on update strategies.
          }

          if (result.status === "ERROR") {
            result.status = _AsyncValidation.AsyncValidationStatus.PENDING;
            return _defineProperty({}, asyncValidationName, _toConsumableArray(asyncValidation));
          }
        }

        return null;
      });
    }
  }, {
    key: "getAsyncValidationReducer",
    value: function getAsyncValidationReducer(asyncValidationName, snapshotValue) {
      return function (tf) {
        this.setState(function (prev) {
          var asyncValidation = prev[asyncValidationName];
          var result = (0, _selectOne.default)(asyncValidation, "value", snapshotValue);
          result.status = tf === true ? _AsyncValidation.AsyncValidationStatus.VALID : _AsyncValidation.AsyncValidationStatus.INVALID;
          return _defineProperty({}, asyncValidationName, _toConsumableArray(asyncValidation));
        });
      }.bind(this);
    }
  }, {
    key: "getAsyncValidationErrorReducer",
    value: function getAsyncValidationErrorReducer(asyncValidationName, snapshotValue, errorHandler) {
      return function (_ref8) {
        var message = _ref8.message;
        this.setState(function (prev) {
          var asyncValidation = prev[asyncValidationName];
          var result = (0, _selectOne.default)(asyncValidation, "value", snapshotValue);
          result.status = _AsyncValidation.AsyncValidationStatus.ERROR;
          return _defineProperty({}, asyncValidationName, _toConsumableArray(asyncValidation));
        }, function () {
          return errorHandler(message);
        });
      }.bind(this);
    }
  }, {
    key: "_isTrue",
    value: function _isTrue(getName, scope) {
      var l = arguments.length <= 2 ? 0 : arguments.length - 2;

      for (var i = 0; i < l; i++) {
        if (!Boolean(scope[getName(i + 2 < 2 || arguments.length <= i + 2 ? undefined : arguments[i + 2])])) return false;
      }

      return true;
    }
  }, {
    key: "isTouched",
    value: function isTouched(scope) {
      for (var _len = arguments.length, names = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        names[_key - 1] = arguments[_key];
      }

      return ReactFormObserver._isTrue.apply(ReactFormObserver, [ReactFormObserver.getTouchedName, scope].concat(names)); // const l = names.length;
      // for (let i = 0; i < l; i++) {
      //   if (!Boolean(props[ReactFormObserver.getTouchedName(names[i])])) return false;
      // }
      // return true;
      // return names.reduce((tf,name) => tf && Boolean(props[ReactFormObserver.getTouchedName(name)]), true);
    }
  }, {
    key: "isSyncValid",
    value: function isSyncValid(scope) {
      for (var _len2 = arguments.length, names = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        names[_key2 - 1] = arguments[_key2];
      }

      return ReactFormObserver._isTrue.apply(ReactFormObserver, [ReactFormObserver.getValidationName, scope].concat(names));
    }
  }, {
    key: "getAsyncResult",
    value: function getAsyncResult(scope, name, value) {
      var asyncValidationName = ReactFormObserver.getAsyncValidationName(name);
      var asyncValidation = scope[asyncValidationName];

      if (Array.isArray(asyncValidation)) {
        return (0, _selectOne.default)(asyncValidation, "value", value);
      }

      return null;
    }
  }]);

  return ReactFormObserver;
}();

var _default = ReactFormObserver;
exports.default = _default;